Option Strict Off

Public Class FontSettings
  Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

  Public Sub New()
    MyBase.New()

    'This call is required by the Windows Form Designer.
    InitializeComponent()

    'Add any initialization after the InitializeComponent() call

  End Sub

  'Form overrides dispose to clean up the component list.
  Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  Private WithEvents label4 As System.Windows.Forms.Label
  Private WithEvents label2 As System.Windows.Forms.Label
  Private WithEvents label3 As System.Windows.Forms.Label
  Private WithEvents groupBox1 As System.Windows.Forms.GroupBox
  Private WithEvents labelSample As System.Windows.Forms.Label
  Private WithEvents listBoxSizes As System.Windows.Forms.ListBox
  Private WithEvents buttonOk As System.Windows.Forms.Button
  Private WithEvents buttonCancel As System.Windows.Forms.Button
  Private WithEvents listBoxFamilies As System.Windows.Forms.ListBox
  Private WithEvents listBoxStyles As System.Windows.Forms.ListBox

  'Required by the Windows Form Designer
  Private components As System.ComponentModel.Container

  'NOTE: The following procedure is required by the Windows Form Designer
  'It can be modified using the Windows Form Designer.  
  'Do not modify it using the code editor.
  <System.Diagnostics.DebuggerStepThrough()> _
  Private Sub InitializeComponent()
    Me.labelSample = New System.Windows.Forms.Label()
    Me.listBoxSizes = New System.Windows.Forms.ListBox()
    Me.buttonOk = New System.Windows.Forms.Button()
    Me.buttonCancel = New System.Windows.Forms.Button()
    Me.listBoxFamilies = New System.Windows.Forms.ListBox()
    Me.listBoxStyles = New System.Windows.Forms.ListBox()
    Me.label2 = New System.Windows.Forms.Label()
    Me.label4 = New System.Windows.Forms.Label()
    Me.groupBox1 = New System.Windows.Forms.GroupBox()
    Me.label3 = New System.Windows.Forms.Label()
    Me.labelSample.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
    Me.labelSample.Location = New System.Drawing.Point(12, 24)
    Me.labelSample.Size = New System.Drawing.Size(344, 80)
    Me.labelSample.TabIndex = 0
    Me.labelSample.Text = "AaBbCcDd - WwXxYyZz"
    Me.labelSample.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
    Me.listBoxSizes.Location = New System.Drawing.Point(320, 28)
    Me.listBoxSizes.Size = New System.Drawing.Size(56, 95)
    Me.listBoxSizes.TabIndex = 2
    Me.buttonOk.Location = New System.Drawing.Point(384, 28)
    Me.buttonOk.TabIndex = 3
    Me.buttonOk.Text = "OK"
    Me.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
    Me.buttonCancel.Location = New System.Drawing.Point(384, 60)
    Me.buttonCancel.TabIndex = 4
    Me.buttonCancel.Text = "Cancel"
    Me.listBoxFamilies.Location = New System.Drawing.Point(12, 28)
    Me.listBoxFamilies.Size = New System.Drawing.Size(196, 95)
    Me.listBoxFamilies.TabIndex = 0
    Me.listBoxStyles.Location = New System.Drawing.Point(216, 28)
    Me.listBoxStyles.Size = New System.Drawing.Size(96, 95)
    Me.listBoxStyles.TabIndex = 1
    Me.label2.Location = New System.Drawing.Point(216, 12)
    Me.label2.Size = New System.Drawing.Size(120, 20)
    Me.label2.TabIndex = 7
    Me.label2.Text = "Font Style"
    Me.label4.Location = New System.Drawing.Point(320, 12)
    Me.label4.Size = New System.Drawing.Size(52, 20)
    Me.label4.TabIndex = 9
    Me.label4.Text = "Size"
    Me.groupBox1.Controls.AddRange(New System.Windows.Forms.Control() _
      {Me.labelSample})
    Me.groupBox1.Location = New System.Drawing.Point(12, 136)
    Me.groupBox1.Size = New System.Drawing.Size(364, 112)
    Me.groupBox1.TabIndex = 5
    Me.groupBox1.TabStop = False
    Me.groupBox1.Text = "Sample"
    Me.label3.Location = New System.Drawing.Point(12, 12)
    Me.label3.Size = New System.Drawing.Size(120, 20)
    Me.label3.TabIndex = 8
    Me.label3.Text = "Font Family"
    Me.AcceptButton = Me.buttonOk
    Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
    Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
    Me.CancelButton = Me.buttonCancel
    Me.ClientSize = New System.Drawing.Size(473, 262)
    Me.Controls.AddRange(New System.Windows.Forms.Control() _
        {Me.listBoxSizes, Me.listBoxStyles, Me.listBoxFamilies, Me.label4, _
        Me.label3, Me.label2, Me.groupBox1, Me.buttonCancel, Me.buttonOk})
    Me.MaximizeBox = False
    Me.MinimizeBox = False
    Me.Text = "Font Settings"

  End Sub

  Private Sub formFontSettings_Load(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load

    'purpose:   init. the controls on the form

    'declare variables of local scope
    Dim myFonts As System.Drawing.Text.InstalledFontCollection
    Dim i As Integer
    Dim myType As System.Type
    Dim myStyle As FontStyle
    Dim myArray() As String

    'return the collection of installed fonts
    myFonts = New System.Drawing.Text.InstalledFontCollection()

    'loop throught the font families and add to the list box
    For i = 1 To UBound(myFonts.Families)
      listBoxFamilies().Items.Add(myFonts.Families(i).Name)
    Next

    'get a type object based on the font style enumeration
    myType = myStyle.GetType()

    'fill an array with the font style member names
    myArray = myStyle.GetNames(myType)

    'loop throught the array
    For i = 0 To UBound(myArray)

      'fill the list box with the font styles
      listBoxStyles().Items.Add(myArray(i))

    Next

    'add basic font sizes
    listBoxSizes().Items.Add("8")
    listBoxSizes().Items.Add("10")
    listBoxSizes().Items.Add("12")
    listBoxSizes().Items.Add("14")
    listBoxSizes().Items.Add("18")
    listBoxSizes().Items.Add("24")
    listBoxSizes().Items.Add("36")
    listBoxSizes().Items.Add("48")
    listBoxSizes().Items.Add("72")

    'select the current settings in the lists
    listBoxStyles().SelectedItem = g_FontStyle
    listBoxFamilies().SelectedItem = g_FontFamily
    listBoxSizes().SelectedItem = g_FontSize

  End Sub

  Private Sub setSampleText()

    'purpose:   reset the sample label as a visual cue to users

    'local scope
    Dim font As Font
    Dim fontStyle As FontStyle
    Dim fontFamily As FontFamily
    Dim styleType As System.Type
    Dim fontFamilyName As String
    Dim fontSize As String
    Dim fontStyleName As String

    'get values from family list box
    If listBoxFamilies().SelectedIndex = -1 Then

      'nothing is selected: set to default
      fontFamilyName = g_FontFamily

    Else

      'return selected item
      fontFamilyName = listBoxFamilies().SelectedItem.ToString

    End If

    'get values from size list box
    If listBoxSizes().SelectedIndex = -1 Then

      'nothing is selected: set to default
      fontSize = g_FontSize

    Else

      'return selected item
      fontSize = listBoxSizes().SelectedItem.ToString

    End If

    'get values from the style list box
    If listBoxStyles().SelectedIndex = -1 Then

      'nothing is selected: set to default
      fontStyleName = g_FontStyle

    Else

      'return selected item
      fontStyleName = listBoxStyles().SelectedItem.ToString

    End If

    'set a font style type
    styleType = fontStyle.GetType

    'create a font family object
    fontFamily = New FontFamily(fontFamilyName)

    'get a font style object (note: must turn off option strict)
    fontStyle = fontStyle.Parse(enumType:=styleType, value:=fontStyleName)

    'create a new font based on global values
    font = New Font(family:=fontFamily, _
        emSize:=CSng(fontSize), _
        style:=fontStyle, _
        unit:=System.Drawing.GraphicsUnit.Point)

    'reset the font on the label control
    labelSample().Font = font

  End Sub

  Private Sub buttonOk_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles buttonOk.Click

    'purpose:   respond to the user's request to apply the form's changes

    'reset the aplication's font settings from the list boxes
    g_FontFamily = listBoxFamilies().SelectedItem.ToString()
    g_FontSize = listBoxSizes().SelectedItem.ToString()
    g_FontStyle = listBoxStyles().SelectedItem.ToString()

    'apply the settings to the rich text box
    Call g_FontPad.resetRichTextBox()

    'close the dialog
    Me.Close()

  End Sub

  Private Sub buttonCancel_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles buttonCancel.Click

    'purpose:   respond to the user's request to cancel the form

    'close the font settings dialog
    Me.Close()

  End Sub

  Private Sub listBoxFamilies_SelectedIndexChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles listBoxFamilies.SelectedIndexChanged

    'purpose:   synch. the sample lable with the selected item

    'call the sample update procedure
    Call setSampleText()

  End Sub

  Private Sub listBoxStyles_SelectedIndexChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles listBoxStyles.SelectedIndexChanged

    'purpose:   synch. the sample lable with the selected item

    'call the sample update procedure
    Call setSampleText()

  End Sub

  Private Sub listBoxSizes_SelectedIndexChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles listBoxSizes.SelectedIndexChanged

    'purpose:   synch. the sample lable with the selected item

    'call the sample update procedure
    Call setSampleText()

  End Sub

#End Region

End Class
